//-----------------------------------------------------------
// 
// SWE2007: Software Experiment II (Fall 2014)
//
// Skeleton code for PA #3
// November 5, 2014
//
// Woo-Yeong Jeong
// Computer Systems Laboratory
// Sungkyunkwan University
//
//-----------------------------------------------------------

#include <stdlib.h>

#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "string_sw.h"


char *pwd (int full)
{
    static char buffer[1024];
    char *ptr;
    if (getcwd(buffer, 1024) != buffer)
        return NULL;

    if (full)
        return buffer;
    
    if (strcmp("/", buffer) == 0)
        return buffer;

    ptr = strrchr(buffer, '/');
    return ptr+1;
}

void print_prompt()
{
    int ret;
    char *ptr = pwd(0);
    char head[200];

    if (!ptr)
        exit(1);
    if (strlen(ptr) > 190)
        exit(1);

    strcpy(head, "swsh:");
    strcat(head, ptr);
    strcat(head, "> ");

    ret = write(2, head, strlen(head));
    if (ret <= 0)
        exit(1);
}

int main(void)
{
    int ret;
    char input[240];

    while (1) {
        print_prompt();

        ret = read(0, input, 200);
        if (ret < 0)
            exit(1);
        else if (ret == 0) {
            write(2, "exit\n", 5);
            break;
        }

        write(2, input, ret);
    }

    return 0;
}
